from flask_wtf import FlaskForm
from flask_wtf.file import FileField, FileRequired, FileAllowed
from wtforms import StringField, TextAreaField
from wtforms.validators import DataRequired


class CollectionCreateForm(FlaskForm):
    title = StringField('標題', validators=[DataRequired()])
    image = FileField('圖片', validators=[
        FileRequired(), FileAllowed(['jpg', 'png', 'gif', 'webp'], 'Images only!')])
    description = TextAreaField('內容描述', validators=[DataRequired()])
